﻿init python:
    import pygame
    import math
    import random
    import time
    random.seed(time.perf_counter_ns())
    renpy.music.register_channel("sfx1", "sfx", False)
    renpy.music.register_channel("sfx2", "sfx", False)
    def distance(x, y):
        if x >= y:
            result = x - y
        else:
            result = y - x
        return result
    class shoomup_enemy(renpy.Displayable):
        def __init__(self, image, x, y, parent, bullet = None):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.parent = parent
            self.bullet = bullet

            self.visible = True
            self.x_velocity = 0
            self.y_velocity = 2

            self.rotation = 0

            self.movement_pattern = 1
            self.bullet_velocity = 4
            self.y_trigger = -160
            self.movement_timer = 0
            self.cool_down = 0
            self.bullets_shot = 0
        def got_shot(self):
            renpy.play("shoomup/enemy_explode.ogg", "sfx1")
            self.visible = False
            self.parent.spawn_explosion(self.x, self.y)
            self.parent.kill_count += 1
        def shoot(self):
            if not self.cool_down:
                renpy.play("shoomup/enemy_shoot.ogg", "sfx1")
                bullet = shoomup_enemy_bullet(self.bullet, self.x, self.y, self.parent)
                bullet.y_velocity = 4
                self.parent.enemy_bullets.append(bullet)
                self.cool_down = 100
                self.bullets_shot += 1
                renpy.restart_interaction()
        def movement_check(self):
            if  self.movement_pattern in [1, 8]:
                pass
            elif  self.movement_pattern == 2:
                if self.x_velocity == 0:
                    self.x_velocity = random.choice([-2,2])
                elif abs(self.x) > 140:
                    self.x_velocity = -self.x_velocity
            elif self.movement_pattern == 3:
                self.rotation += -10
                if distance(self.x, self.parent.fighter.x) < 8:
                    pass
                elif self.x > self.parent.fighter.x:
                    self.x_velocity = -2
                elif self.x < self.parent.fighter.x:
                    self.x_velocity = 2
            elif self.movement_pattern == 4:
                if self.y > -150:
                    if self.x_velocity == 0:
                        self.x_velocity = random.choice([-3,3])
                    elif abs(self.x) > 140:
                        self.x_velocity = -self.x_velocity
                    if distance(self.x, self.parent.fighter.x) < 8:
                        self.y_velocity = 5
                        self.x_velocity = 0
                        self.movement_pattern = 1
            elif self.movement_pattern == 6:
                self.shoot()
            elif self.movement_pattern == 7:
                if self.x_velocity == 0:
                    self.x_velocity = random.choice([-2,2])
                    self.y_velocity = 0
                elif abs(self.x) > 140:
                    self.x_velocity = -self.x_velocity
                if distance(self.x, self.parent.fighter.x) < 8:
                    self.shoot()
                    if self.bullets_shot > 4:
                        self.y_velocity = 2
            else:
                pass
        def render(self,width,height,st,at):
            if self.visible:
                if self.cool_down > 0:
                    self.cool_down -= 1
                    if self.cool_down < 0:
                        self.cool_down = 0
                
                self.x += self.x_velocity
                self.y += self.y_velocity

                if -160 < self.y:
                    self.movement_check()
                if self.y > 180:
                    self.visible = False


                t = Transform(self.image, xanchor=0.5, yanchor=0.5, rotate=self.rotation)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x,self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
    class shoomup_enemy_bullet(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.parent = parent
            self.x_velocity = 0
            self.y_velocity = 0
            self.visible = True

        def render(self,width,height,st,at):
            if self.visible:
                self.x += self.x_velocity
                self.y += self.y_velocity
                if self.y > 180:
                    self.visible = False

                if self.parent.fighter.visible:
                    if distance(self.y, self.parent.fighter.y) < 8:
                        if distance(self.x, self.parent.fighter.x) < 16:
                            self.visible = False
                            self.parent.fighter.got_shot()

                t = Transform(self.image, xanchor=0.5, yanchor=0.5,)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x,self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
    class shoomup_player_bullet(renpy.Displayable):
        def __init__(self, image, x, y, parent):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = x
            self.y = y
            self.parent = parent
            self.x_velocity = 0
            self.y_velocity = 0
            self.visible = True

        def render(self,width,height,st,at):
            if self.visible:
                self.x += self.x_velocity
                self.y += self.y_velocity
                for i in self.parent.enemies:
                    if i.visible:
                        if distance(self.y, i.y) < 16:
                            if distance(self.x, i.x) < 16:
                                self.visible = False
                                i.got_shot()

                if self.y < -180:
                    self.visible = False

                t = Transform(self.image, xanchor=0.5, yanchor=0.5,)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x,self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
    class shoomup_fighter(renpy.Displayable):
        def __init__(self, name, image, bullet, portrait,  shoot_sound, info, gun_offset = 0,):
            super(renpy.Displayable,self).__init__()
            self.name = name
            self.image = image
            self.bullet = bullet
            self.portrait = portrait
            self.info = info
            self.parent = None
            self.gun_offset = gun_offset
            self.shoot_sound = shoot_sound
            self.x = 0
            self.y = 100

            self.w = 0
            self.a = 0
            self.s = 0
            self.d = 0

            self.speed = 3
            self.visible = True
        def reset(self):
            self.visible = True
            self.render(0,0,0,0)

        def shoot(self):
            renpy.play(self.shoot_sound, "sound")
            self.gun_offset = -self.gun_offset
            bullet = shoomup_player_bullet(self.bullet, self.x + self.gun_offset, self.y, self.parent)
            bullet.y_velocity = -10
            self.parent.player_bullets.append(bullet)
        def got_shot(self):
            renpy.play("shoomup/explode.ogg", "sfx2")
            self.visible = False
            self.parent.spawn_explosion(self.x, self.y)

        def render(self,width,height,st,at):
            if self.visible:
                self.x += (self.a + self.d)*self.speed
                self.y += (self.w + self.s)*self.speed
                if self.y > 164:
                    self.y = 164
                elif self.y < -174:
                    self.y = -174
                if self.x > 145:
                    self.x = 145
                elif self.x < -145:
                    self.x = -145

                for i in self.parent.enemies:
                    if distance(self.y, i.y) < 16:
                        if distance(self.x, i.x) < 16:
                            i.got_shot()
                            self.got_shot()

                t = Transform(self.image, xanchor=0.5, yanchor=0.5,)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x,self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0,0)
                

        def event(self, ev, x, y, st):
            if ev.type == pygame.KEYDOWN:
                if ev.key == pygame.K_a:
                    self.a = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_d:
                    self.d = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                if ev.key == pygame.K_w:
                    self.w = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_s:
                    self.s = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

            elif ev.type == pygame.KEYUP:
                if ev.key == pygame.K_a:
                    self.a = 0
                elif ev.key == pygame.K_d:
                    self.d = 0
                if ev.key == pygame.K_w:
                    self.w = 0
                elif ev.key == pygame.K_s:
                    self.s = 0
            return None

    class shoomup_level:
        def __init__(self, name, fighter, enemy_list):
            self.name = name
            self.fighter = fighter
            self.enemy_list = enemy_list
            self.enemies = []
            self.enemy_bullets = []
            self.player_bullets = []
            self.tries = 0
            self.kill_count = 0

        def set_fighter(self, fighter):
            fighter.parent = self
            self.fighter = fighter
        def spawn_explosion(self, x, y):
            tag = f"shum_ex_{random.randint(0,10000)}"
            Show("shoomup_explosion", x = x, y = y, z = 8, tag = tag, _tag = tag)()
        def spawn(self):
            for i in self.enemy_bullets:
                if not i.visible:
                    self.enemy_bullets.remove(i)
            for i in self.player_bullets:
                if not i.visible:
                    self.player_bullets.remove(i)
            for i in self.enemies:
                if not i.visible:
                    self.enemies.remove(i)
            if len(self.enemies) < 5:
                e = random.choice(self.enemy_list)
                enemy = shoomup_enemy(e[0], random.randint(-140, 140), -190, self)
                enemy.movement_pattern = e[1]
                if len(e) > 2:
                    enemy.bullet = e[2]
                    enemy.bullet_velocity = e[3]
                if e[1] == 8:
                    enemy.y_velocity = 4
                enemy.y_trigger = random.randint(-160, -130)
                self.enemies.append(enemy)
        def restart(self):
            self.kill_count = 0
            self.enemies = []
            self.enemy_bullets = []
            self.player_bullets = []
            self.fighter.reset()
            self.tries = 0

screen shoomup_choose_a_fighter(fighters):
    modal True
    hbox:
        align .5,.5 spacing 20
        for i in fighters:
            button:
                at zoom(3, True) xysize 130,180 padding 7,7
                background Frame("shoomup/frame.png", 40,40,4,4)
                add i.portrait align .0,.0
                vbox:
                    yoffset 36 spacing 10
                    text i.name size 10 antialias False
                    text i.info size 9 antialias False
                    add i.image xalign .5
                action Return(i)
screen shoomup_explosion(x,y,z,tag):
    fixed:
        xysize 320,180 align .5,.5
        at zoom(3, True)
        add "shoomup_explosion" align .5,.5 offset x,y
    timer 1 repeat True action Hide(tag)
screen shoomup(g):
    modal True
    fixed:
        xysize 640,360 align .5,.5
        at zoom(3, True)
        for i in g.enemies:
            add i align .5,.5
        for i in g.enemy_bullets:
            add i align .5,.5
        for i in g.player_bullets:
            add i align .5,.5
        add g.fighter align .5,.5

        add "shoomup/mock-ups.png"
        add g.fighter.portrait align .5,.5 offset 184,-148
        text g.fighter.name align 0,0 offset 521,31 size 9
        text "Modules" align 0,0 offset 62,8 size 9
        fixed:
            xysize 17,10 align 0,0 offset 602,20
            text str(g.kill_count) size 9 xalign .5
    if g.fighter.visible:
        timer 1 repeat True action Function(g.spawn)
        key "K_SPACE" action Function(g.fighter.shoot)
    else:
        hbox:
            spacing 10 align .5,.5
            button:
                padding 20,20 background "#4f171d"
                text "Re-try"
                action Function(g.restart)
            button:
                padding 20,20 background "#4f171d"
                text "Give up"
                action Return(g.kill_count)


    # vbox:
    #     text str(g.fighter.y)
    #     text str(g.fighter.x)
    #     text f"player bullets: {len(g.player_bullets)}"
    #     text f"Enemy bullets: {len(g.enemy_bullets)}"
    #     text f"enemies: {len(g.enemies)}"
    #     text str(g.tries)

init:
    image shoomup_enemy_1 = Crop((32,0,32,32), "shoomup/shoomup_sprites.png")
    image shoomup_enemy_2 = Crop((32,32,32,32), "shoomup/shoomup_sprites.png")
    image shoomup_enemy_3 = Crop((32,64,32,32), "shoomup/shoomup_sprites.png")
    image shoomup_enemy_4 = Crop((32,96,32,32), "shoomup/shoomup_sprites.png")

    image shoomup_enemy_5 = Crop((64,0,32,32), "shoomup/shoomup_sprites.png")
    image shoomup_enemy_6 = Crop((64,32,32,32), "shoomup/shoomup_sprites.png")
    image shoomup_enemy_7 = Crop((64,64,32,32), "shoomup/shoomup_sprites.png")
    image shoomup_enemy_8 = Crop((64,96,16,32), "shoomup/shoomup_sprites.png")

    image shoomup_enemy_9 = Crop((96,0,32,32), "shoomup/shoomup_sprites.png")

    image shoomup_enemy_6_bullet = Crop((96,120,32,8), "shoomup/shoomup_sprites.png")
    image shoomup_enemy_7_bullet = Crop((97,113,5,5), "shoomup/shoomup_sprites.png")

    image crimson_pterodactyl = Crop((0,0,32,32), "shoomup/shoomup_sprites.png")
    image crimson_portrait = Crop((0,64,32,32), "shoomup/shoomup_sprites.png")
    image crimson_laser = Crop((96,96,4,11), "shoomup/shoomup_sprites.png")

    image f22c = Crop((0,32,32,32), "shoomup/shoomup_sprites.png")
    image f22c_portrait = Crop((0,96,32,32), "shoomup/shoomup_sprites.png")
    image f22c_missile = Crop((101,96,5,8), "shoomup/shoomup_sprites.png")
    
    image shoomup_explosion:
        Crop((0,0,32,32), "shoomup/explosion.png")
        .1
        Crop((32,0,32,32), "shoomup/explosion.png")
        .1
        Crop((64,0,32,32), "shoomup/explosion.png")
        .1
        Crop((96,0,32,32), "shoomup/explosion.png")
        .1
        Crop((128,0,32,32), "shoomup/explosion.png")
        .1
        Crop((160,0,32,32), "shoomup/explosion.png")
        .1
        Crop((192,0,32,32), "shoomup/explosion.png")
        .1
        Crop((224,0,32,32), "shoomup/explosion.png")
        .1
        Crop((256,0,32,32), "shoomup/explosion.png")
        .1
        Crop((288,0,32,32), "shoomup/explosion.png")
        .1
        Crop((320,0,32,32), "shoomup/explosion.png")
        .1


    default crimson_pterodactyl = shoomup_fighter(
        "Crimson Pterodactyl",
        "crimson_pterodactyl",
        "crimson_laser",
        "crimson_portrait",
        "shoomup/laser.ogg",
        "A modern killing machine that can bring unimaginable pain and destruction, sitting in a pretty good fighter.",
    )
    default f22c = shoomup_fighter(
        "F22-C",
        "f22c",
        "f22c_missile",
        "f22c_portrait",
        "shoomup/missile.ogg",
        "Modified F22 fighter retro fitted with ion engine and module bay.",
        12,
    )
    default shoomup_fighters = [crimson_pterodactyl, f22c]
    default shoomup_level_1 = shoomup_level(
        name = "Moon",
        fighter = crimson_pterodactyl,
        enemy_list = [
            ["shoomup_enemy_1", 1],
            ["shoomup_enemy_2", 2],
            ["shoomup_enemy_3", 3],
            ["shoomup_enemy_4", 4],
            ["shoomup_enemy_5", 5],
            ["shoomup_enemy_6", 6, "shoomup_enemy_6_bullet", 5],
            ["shoomup_enemy_7", 7, "shoomup_enemy_7_bullet", 4],
            ["shoomup_enemy_8", 8],
            ["shoomup_enemy_9", 9],
        ],
        )

label shoomup_example:
    call screen shoomup_choose_a_fighter(shoomup_fighters)
    $ shoomup_level_1.set_fighter(_return)
    call screen shoomup(shoomup_level_1)




